#!/usr/local/bin/perl


#trajectory read in from file on command line.
#trajectory specified as destination X, Y, speed, pause time

use English;
use strict var;

require 'dumpvar.pl';

my $num_nodes = 1;
my $num_loops = 1;
my @start_times = (0, 56, 112, 168, 224);


my $direction = 1; # should trajectory be read forwards (1) or backwards(-1)

sub DoNode {
    my ($node,$lap_cnt,$rmove) = @ARG;
    my ($lap);

#    print ("move is \n");
#    dumpValue(\$rmove);

#    print "move 1,1 is $$rmove[0][0] #  $#$rmove  \n";

    my ($startx, $starty) = ($$rmove[$#$rmove][0],$$rmove[$#$rmove][1]);
    my ($time) = $start_times[$node-1];

#    print "start time '@start_times' time $time\n";

    print "\$node_($node) set Z_ 0.0\n";
    print "\$node_($node) set Y_ $starty\n";
    print "\$node_($node) set X_ $startx\n";

    
    for ($lap = 0; $lap < $lap_cnt; $lap++) {
	($time, $startx, $starty) = DoLap($startx, $starty, $time,
					  $node, $rmove);
    }
};


sub DoLap {
    
    my ($startx,$starty,$t,$node,$rmove) = @ARG;

    for ($i = 0; $i <= $#$rmove; $i++) {
	
	if (0 != $$rmove[$i][3]) {
	    # handle pause time
	    print "\$ns_ at $t \"\$node_($node) setdest $startx $starty 0.0\"\n";
	    $t += $$rmove[$i][3];
	}
	
	print "\$ns_ at $t \"\$node_($node) setdest $$rmove[$i][0] $$rmove[$i][1] $$rmove[$i][2]\"\n";

	my $d = sqrt( ($startx - $$rmove[$i][0]) * ($startx - $$rmove[$i][0]) 
		     +($starty - $$rmove[$i][1]) * ($starty - $$rmove[$i][1]));
	$t += $d / $$rmove[$i][2];
	($startx, $starty) = ($$rmove[$i][0], $$rmove[$i][1]);
    }
    return ($t, $startx, $starty);
}


my ($j);
my @move;

while (<>) {
    if (/^\W*(\d+.\d+)\W+(\d+.\d+)\W+(\d+.\d+)\W+(\d+.\d+)/) {
	if (0 < $direction) {
	    push(@move, [$1, $2, $3, $4]);
	} else{
	    unshift(@move, [$1, $2, $3, $4]);
	}
    } elsif (/^\s*start times:\s*([\W\d]+)/) {
	@start_times = split(/\s/, $1);
    } elsif (/^\s*nodes:\s*(\d+)/) {
	$num_nodes = $1;
    } elsif (/^\s*loops:\s*(\d+)/) {
	$num_loops = $1;
    } elsif (/^\s*direction:\s*(-?\d+)/) {
	$direction = $1;
    } elsif (/(^\s*$)|(^\s*#)/) {
	# do nothing
    } else {
	die "Can't parse data '$_'\n";
    }
}

#  dumpValue(\@move);


if ($#start_times < $num_nodes - 1) {
    die "number of start times ($#start_times) less than the number of nodes ($num_nodes)!\n";
}

for ($j = 1; $j <= $num_nodes; $j++) {
    DoNode($j, $num_loops, \@move );
}
